/*
    This file is part of the CLib sub-project of the FreeDOS project
    Copyright (C) 1997 by the author see below

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* $RCSfile: SETDISK.C $
   $Locker:  $	$Name:  $	$State: Exp $

	int setdisk(int drive)

	Set the current drive & return the LASTDRIVE setting of CONFIG.SYS.

	Input:
		drive: 0 == A:, 1 == B:

	Return:
		number of available drive letters

	Note:
		<none>

	Conforms to:
		<none>

	See also:
		getdisk

	Target compilers:
		Any C compiler

	Origin:
		1997/10/10 Steffen Kaiser (ska)

	Revised by:
		<none>

	File Revision:    Revision 1.1  1997/10/13 07:05:48  ska
*/

#include <_clib.h>			/* standard include, must be the first! */
#include <dos.h>

#ifdef RCS_Version
static char const rcsid[] = 
	"$Id: SETDISK.C 1.1 1997/10/13 07:05:48 ska Exp $";
#endif

_CLibFunc int
setdisk(int drive)
{	struct REGPACK r;

	r.r_ax = 0x0e00;
	r.r_dx = drive;
	_callDOS(&r);
	return LOBYTE(r.r_ax);
}
